stages:
- prepare
- build
- convert
- deploy

dependencies:
  image: 'node:latest'
  stage: prepare
  script:
    - npm install
  artifacts:
    paths:
      - node_modules
    expire_in: 2 hrs

build:
  image: 'node:latest'
  stage: build
  needs:
    - job: dependencies
  script:
    - npm run build
  artifacts:
    paths:
      - /
    expire_in: 2 hrs

static-export:
  image: 'node:latest'
  stage: convert
  needs:
    - job: build
  script:
    - npm run export
  artifacts:
    paths:
      - out
    expire_in: 2 hrs

# docker-deploy:
#   image: docker:latest
#   stage: deploy
#   needs:
#     - job: build
#   services:
#     - docker:dind
#   before_script:
#     - docker login -u "confusedant" -p "$CI_REGISTRY_PASSWORD" docker.io
#   script:
#     - docker build --pull -t "$CI_REGISTRY_IMAGE" .
#     - docker push "$CI_REGISTRY_IMAGE"
#   rules:
#     - if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH

static-deploy:
  image: ubuntu:21.04
  stage: deploy
  needs:
    - job: static-export
  before_script:
    - apt-get update -qy
    - apt-get install -y lftp
  script:
    - lftp -e "set ftp:ssl-allow no; open sl240.web.hostpoint.ch; user '$FTP_USERNAME' '$FTP_PASSWORD'; mirror -X .* -X .*/ --reverse --verbose --delete out/ /; bye"